@ECHO OFF

REM ******************************************************************
REM Desinstalacin de servicios anteriores
REM ******************************************************************
..\SetUpgradeProgress 35 "Removing files..."
Content\Publisher\HPPublisher.exe -uninstall -silent
Content\HTTPServer\HPWebServer.exe -uninstall -silent
Content\Server\HPServer.exe -uninstall -silent
Content\DBServer\HPDBServer.exe -uninstall -silent

REM ******************************************************************
REM Desinstalacin de clases anteriores
REM ******************************************************************
..\SetUpgradeProgress 40 "Removing files..."
REGSVR32 -s -u "C:\HPBox\Automation\HPObjectsLib.dll"
REGSVR32 -s -u "C:\HPBox\Automation\HPExtensionsLib.dll"
REGSVR32 -s -u "C:\HPBox\Extensions\Climate.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\DoorLocks.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\Intrusion.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\Lightswitch.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\Notifications.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\RadioThermostat.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\Solidmation.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\Sonos.hpe"
REGSVR32 -s -u "C:\HPBox\Extensions\Video.hpe"

REM ******************************************************************
REM Eliminacin de archivos anteriores
REM ******************************************************************
..\SetUpgradeProgress 45 "Removing files..."
DEL C:\Bootloader\HPAppliance.old
DEL C:\HPBox\*.exe /s/q
DEL C:\HPBox\*.dll /s/q
DEL C:\HPBox\*.old /s/q
DEL C:\HPBox\Images\*.gif
DEL C:\HPBox\Images\*.png
DEL C:\HPBox\Images\*.jpg
DEL C:\HPBox\Images\*.ico
DEL C:\HPBox\Images\Buttons\*.gif
DEL C:\HPBox\Images\Buttons\*.png
DEL C:\HPBox\Images\Buttons\*.jpg
DEL C:\HPBox\Images\Buttons\*.ico
DEL C:\HPBox\Images\Sonos\*.gif
DEL C:\HPBox\Images\Sonos\*.png
DEL C:\HPBox\Images\Sonos\*.jpg
DEL C:\HPBox\Images\Sonos\*.ico
REN C:\HPBox\Server\*.exe *.old
REN C:\HPBox\VideoServer\*.exe *.old
REN C:\HPBox\HTTPServer\*.exe *.old
REN C:\HPBox\DBServer\*.exe *.old
REN C:\HPBox\Plugins\Publisher\*.exe *.old
REN C:\HPBox\Publisher\*.exe *.old
DEL C:\HPBox\Images\Video\*.* /s/q
RD  C:\HPBox\Images\Video /s/q
RD  C:\HPBox\Plugins\Publisher /s/q
MD  C:\HPBox\Images\Hashes
DEL C:\HPBox\Images\Hashes\*.* /s/q

REM ******************************************************************
REM Instalacin de archivos nuevos
REM ******************************************************************
..\SetUpgradeProgress 50 "Installing new files..."
XCOPY Content\*.* C:\HPBox /S/E/Y
REN C:\HPBox\Data\HomePlanner.mdb HabeetatPlanner.mdb

REM ******************************************************************
REM Copia del instalador de AnyDesk
REM ******************************************************************
XCOPY AnyDesk.exe C:\HPBox /Y
XCOPY AnyDeskInstall.bat C:\HPBox /Y

REM ******************************************************************
REM Movemos los logs viejos del server a la carpeta Data\Logs
REM ******************************************************************
MD C:\HPBox\Data\Logs
XCOPY C:\HPBox\Server\*.log C:\HPBox\Data\Logs /Y
DEL C:\HPBox\Server\*.log

REM ******************************************************************
REM Configuracin horaria
REM ******************************************************************
sc config W32Time start=auto
sc start W32Time

REM ******************************************************************
REM Configuracin del firewall
REM ******************************************************************
..\SetUpgradeProgress 60 "Setting up network security..."
netsh.exe advfirewall firewall delete rule name="Gear Blocks appliance - power meter interface"
netsh.exe advfirewall firewall delete rule name="Gear Blocks appliance"
netsh.exe advfirewall firewall delete rule name="Habeetat TCP/80"
..\SetUpgradeProgress 61 "Setting up network security..."
netsh.exe advfirewall firewall delete rule name="Habeetat TCP/8000"
netsh.exe advfirewall firewall delete rule name="Habeetat UDP/8000"
netsh.exe advfirewall firewall delete rule name="Habeetat TCP/8001"
..\SetUpgradeProgress 62 "Setting up network security..."
netsh.exe advfirewall firewall delete rule name="Habeetat TCP/9000"
netsh.exe advfirewall firewall delete rule name="Gear Blocks appliance firmware setup"
netsh.exe advfirewall firewall delete rule name="Gear Blocks appliance network setup"
..\SetUpgradeProgress 63 "Setting up network security..."
netsh.exe advfirewall firewall delete rule name="Gear Blocks setup utility"
netsh.exe advfirewall firewall delete rule name="Gear Blocks appliance (TCP)"
netsh.exe advfirewall firewall delete rule name="Gear Blocks appliance (UDP)"
..\SetUpgradeProgress 64 "Setting up network security..."
netsh.exe advfirewall firewall add rule name="Gear Blocks appliance (TCP)" dir=in action=allow enable=yes protocol=TCP localport=80,7000-7005,8000,8001,9000
netsh.exe advfirewall firewall add rule name="Gear Blocks appliance (UDP)" dir=in action=allow enable=yes protocol=UDP localport=8000,20911
..\SetUpgradeProgress 65 "Setting up network security..."
netsh.exe advfirewall firewall add rule name="Gear Blocks appliance (CoAP)" dir=in action=allow enable=yes protocol=UDP localport=5683

REM ******************************************************************
REM Instalacin de servicios
REM ******************************************************************
..\SetUpgradeProgress 70 "Installing daemons..."
C:\HPBox\DBServer\HPDBServer.exe -install -silent
..\SetUpgradeProgress 75 "Installing daemons..."
C:\HPBox\Server\HPServer.exe -install -silent
..\SetUpgradeProgress 80 "Installing daemons..."
C:\HPBox\HTTPServer\HPWebServer.exe -install -silent
..\SetUpgradeProgress 85 "Installing daemons..."
C:\HPBox\VideoServer\HPVideoServer.exe -install -silent
..\SetUpgradeProgress 90 "Installing daemons..."
C:\HPBox\Publisher\HPPublisher.exe -install -silent

REM ******************************************************************
REM Instalacin de clases nuevas
REM ******************************************************************
..\SetUpgradeProgress 92 "Installing daemons..."
REGSVR32 -s "C:\HPBox\Automation\HPObjectsLib.dll"

REM ******************************************************************
REM Listo. Reiniciamos.
REM ******************************************************************
..\SetUpgradeProgress 95 "Restarting..."
..\Restart
